unit Main.Form;

interface

{$REGION 'interface uses'}
uses
  Winapi.Windows,
  Winapi.Messages,
  System.SysUtils,
  System.Variants,
  System.Classes,
  Vcl.Graphics,
  Vcl.Forms,
  Vcl.Dialogs,
  Vcl.StdCtrls,
  Vcl.Controls,
  Vcl.Buttons,
  Vcl.ExtCtrls, AdvGroupBox, AdvOfficeButtons, Vcl.CheckLst;
{$ENDREGION}

type
  TfrmMain = class(TForm)
    Toolbar2: TPanel;
    btnTool3: TSpeedButton;
    lblState: TLabel;
    chkgrp:   TAdvOfficeCheckGroup;
    clb:      TCheckListBox;
    procedure FormCreate(Sender: TObject);
    procedure btnTool3Click(Sender: TObject);
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}
{$R RES\Namen.res}

function LoadResourceToStrings(const AResName, AResType: string; AStrings: TStrings): Boolean;
///****************************************************************************************
///  TStrings aus RES-Datei laden
///
///  Seit: 2004-01-08 [OH]
///****************************************************************************************
begin
  Result := False;

  if not Assigned(AStrings) then Exit;

  var strm: TResourceStream := TResourceStream.Create(hInstance, AResName, PChar(AResType));
  try
    AStrings.LoadFromStream(strm);

    Result := True;
  finally
    strm.Free;
  end;
end;


procedure TfrmMain.FormCreate(Sender: TObject);
begin
  chkgrp.DoubleBuffered := True;
end;

/// RC-Datei zur RES-Datei kompilieren:
///
/// Kommandozeile "brcc32.exe" Namen.rc
///
/// ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
///
/// Namen.rc
/// -----------------------------------
/// VORNAMEN_MAENNLICH CSV Mnnlich.csv
/// VORNAMEN_WEIBLICH CSV Weiblich.csv
/// -----------------------------------

procedure TfrmMain.btnTool3Click(Sender: TObject);
var
  tick: Cardinal;
  sltM,
  sltW: TStrings;
  itms: TStrings;
  s:    string;
begin
  lblState.Caption := 'Start...   ';
  lblState.Update;

  sltM := TStringList.Create;
  sltW := TStringList.Create;
  try
    LoadResourceToStrings('VORNAMEN_WEIBLICH',  'CSV', sltW);
    LoadResourceToStrings('VORNAMEN_MAENNLICH', 'CSV', sltM);

    var c: Integer := sltM.Count;
    if sltW.Count < c then c := sltW.Count;
//  c := 150;
    Dec(c);

    s := '';
    for var x := 0 to 1 do
    begin
      case x of
        0: itms := chkgrp.Items;  // TAdvOfficeCheckGroup
        1: itms := clb.Items;     // Delphi TCecklistBox
      end;

      tick := GetTickCount;

      itms.Clear;
      itms.BeginUpdate;
      try
        for var i: Integer := 0 to c do
          itms.Add(sltW[i] + ' ' + sltM[i]);
      finally
        itms.EndUpdate;
      end;

      s := s + #13#10 + 'Count: ' + itms.Count.ToString + '  Ready: ' + (GetTickCount - tick).ToString + '   ';
    end;
  finally
    sltM.Free;
    sltW.Free;

    lblState.Caption := s;
    lblState.Update;
  end;
end;

end.
